namespace ILoan.Tools.Domain;

public partial class RulesContext : DbContext
{
    public RulesContext()
    {
    }

    public RulesContext(DbContextOptions<RulesContext> options) : base(options)
    {
    }

    partial void OnModelBuilding(ModelBuilder builder);

    protected override void OnModelCreating(ModelBuilder builder)
    {
        base.OnModelCreating(builder);

        builder.Entity<CoreRuleCriteriaOperator>()
            .HasOne(i => i.CoreRule)
            .WithMany(i => i.CoreRuleCriteriaOperators)
            .HasForeignKey(i => i.RuleID)
            .HasPrincipalKey(i => i.ID);

        builder.Entity<CoreRuleCriterion>()
            .HasOne(i => i.CoreRule)
            .WithMany(i => i.CoreRuleCriteria)
            .HasForeignKey(i => i.RuleID)
            .HasPrincipalKey(i => i.ID);

        builder.Entity<CoreRule>()
            .Property(p => p.UseLastRecord)
            .HasDefaultValueSql(@"true");

        builder.Entity<CoreRuleCriterion>()
            .Property(p => p.ValueIsProperty)
            .HasDefaultValueSql(@"false");

        builder.Entity<CoreRuleCriterion>()
            .Property(p => p.ReturnCount)
            .HasDefaultValueSql(@"false");

        builder.Entity<CoreRuleCriterion>()
            .Property(p => p.IsThresholdCriterium)
            .HasDefaultValueSql(@"false");
        this.OnModelBuilding(builder);
    }

    public DbSet<CoreRuleCriteriaOperator> CoreRuleCriteriaOperators { get; set; }

    public DbSet<CoreRule> CoreRules { get; set; }

    public DbSet<CoreRuleCriterion> CoreRuleCriteria { get; set; }

    protected override void ConfigureConventions(ModelConfigurationBuilder configurationBuilder)
    {
        configurationBuilder.Conventions.Add(_ => new BlankTriggerAddingConvention());
    }
}